Prefix Flag Extension for OSPFv2 and OSPFv3
RFC 9792
Ran Chen
ZTE Corporation
Detao Zhao
ZTE Corporation
Peter Psenak
Cisco Systems
Ketan Talaulikar
Cisco Systems
Liyan Gong
China Mobile
2025-06
RTG
lsr
Each OSPF prefix can be advertised with an 8-bit field to indicate specific properties of that prefix. However, all the OSPFv3 Prefix Options bits have already been assigned, and only a few bits remain unassigned in the Flags field of the OSPFv2 Extended Prefix TLV.
This document solves this problem by defining a variable-length Prefix Extended Flags sub-TLV for OSPF. This sub-TLV is applicable to OSPFv2 and OSPFv3.
Status of This Memo
This is an Internet Standards Track document.
This document is a product of the Internet Engineering Task Force (IETF). It represents the consensus of the IETF community. It has received public review and has been approved for publication by the Internet Engineering Steering Group (IESG). Further information on Internet Standards is available in Section 2 of RFC 7841.
Information about the current status of this document, any errata, and how to provide feedback on it may be obtained at https://www.rfc-editor.org/info/rfc9792.
Copyright Notice
Copyright (c) 2025 IETF Trust and the persons identified as the document authors. All rights reserved.
This document is subject to BCP 78 and the IETF Trust's Legal Provisions Relating to IETF Documents (https://trustee.ietf.org/license-info) in effect on the date of publication of this document. Please review these documents carefully, as they describe your rights and restrictions with respect to this document. Code Components extracted from this document must include Revised BSD License text as described in Section 4.e of the Trust Legal Provisions and are provided without warranty as described in the Revised BSD License.
Table of Contents
- 1. Introduction
  - 1.1. Requirements Language
- 2. Variable-Length Prefix Extended Flags Sub-TLV
- 3. Backward Compatibility
- 4. IANA Considerations
  - 4.1. OSPFv2
    - 4.1.1. OSPFv2 Prefix Extended Flags Sub-TLV
    - 4.1.2. OSPFv2 Prefix Extended Flags Registry
  - 4.2. OSPFv3
    - 4.2.1. OSPFv3 Prefix Extended Flags Sub-TLV
    - 4.2.2. OSPFv3 Prefix Extended Flags Registry
- 5. Security Considerations
- 6. References
  - 6.1. Normative References
  - 6.2. Informative References
- Acknowledgements
- Authors' Addresses
Introduction
Each OSPF prefix can be advertised with an 8-bit field to indicate specific properties of that prefix. This is done using the OSPFv3 Prefix Options (Appendix A.4.1.1 of [RFC5340]) and the Flags field in the OSPFv2 Extended Prefix TLV (Section 2.1 of [RFC7684]). The rest of this document refers to these 8-bit fields in both OSPFv2 and OSPFv3 as the "existing fixed-size prefix flags".
However, all the OSPFv3 Prefix Options bits have already been assigned (see the "OSPFv3 Prefix Options (8 bits)" IANA registry [IANA-OSPFv3-PO]). Also, at the time of publication of this document, only 5 bits remain unassigned in the Flags field of the OSPFv2 Extended Prefix TLV (see the "OSPFv2 Extended Prefix TLV Flags" IANA registry [IANA-OSPFv2-EPF]).
This document solves the problem of insufficient flag bits for the signaling of prefix properties in OSPF by defining a variable-length Prefix Extended Flags sub-TLV for OSPFv2 and OSPFv3.
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Variable-Length Prefix Extended Flags Sub-TLV
This document defines a variable-length Prefix Extended Flags sub-TLV for OSPFv2 and OSPFv3. The sub-TLV specifies the variable-length Prefix Extended Flags field to advertise additional attributes associated with OSPF prefixes. The advertisement and processing of the existing fixed-size prefix flags remain unchanged.
The format of the OSPFv2/OSPFv3 Prefix Extended Flags sub-TLV is shown in Figure 1.
Format of OSPFv2/OSPFv3 Prefix Extended Flags Sub-TLV

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|              Type             |            Length             |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                                                               |
//                 Prefix Extended Flags (Variable)            //
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
where:
Type (2 octets):
11 for OSPFv2 and 37 for OSPFv3
Length (2 octets):
Variable, dependent on the included Prefix Extended Flags field. This indicates the length of the Prefix Extended Flags field in octets. The length MUST be a multiple of 4 octets. If the length is not a multiple of 4 octets, the Link State Advertisement (LSA) is malformed and MUST be ignored.
Prefix Extended Flags (Variable):
The extended flag field. This field contains a variable number of flags, grouped in 4-octet blocks. The bits are numbered starting from bit 0 as the most significant bit of the first 32-bit block. If the length of the Prefix Extended Flags field exceeds 4 octets, numbering for the additional bits picks up where the previous 4-octet block left off. For example, the most significant bit in the fifth octet of an 8-octet Prefix Extended Flags field is referred to as bit 32. Currently, no bits are defined in this document.
Unassigned bits MUST be set to zero on transmission and MUST be ignored on receipt.
An implementation MUST limit the length of the sub-TLV so as to signal the bits that are set to 1. Defined prefix flags that are not transmitted due to being beyond the transmitted length MUST be treated as being set to 0.
The OSPFv2 Prefix Extended Flags sub-TLV is advertised as a sub-TLV of the OSPFv2 Extended Prefix TLV defined in [RFC7684]. Additional OSPFv2 prefix flags SHOULD be allocated from the unused bits in the Flags field of the OSPFv2 Extended Prefix TLV prior to allocating flags in the OSPFv2 Prefix Extended Flags sub-TLV.
The OSPFv3 Prefix Extended Flags sub-TLV is advertised as a sub-TLV of the following OSPFv3 TLVs:
- Inter-Area-Prefix TLV (Section 3.4 of [RFC8362])
- External-Prefix TLV (Section 3.6 of [RFC8362])
- Intra-Area-Prefix TLV (Section 3.7 of [RFC8362])
- SRv6 Locator TLV [RFC9513]
When multiple instances of the OSPFv2/OSPFv3 Prefix Extended Flags sub-TLVs are received within the same TLV, an implementation MUST use only the first occurrence of the sub-TLV and MUST ignore all subsequent instances of the sub-TLV. Errors SHOULD be logged subject to rate limiting.
Backward Compatibility
The OSPFv2/OSPFv3 Prefix Extended Flags sub-TLV does not introduce any backward compatibility issues. An implementation that does not recognize the OSPFv2/OSPFv3 Prefix Extended Flags sub-TLV would ignore the sub-TLV as per normal TLV processing operations (refer to Section 2.3.2 of [RFC3630] and Section 6.3 of [RFC8362]).
IANA Considerations
OSPFv2
OSPFv2 Prefix Extended Flags Sub-TLV
IANA has allocated the following codepoint in the "OSPFv2 Extended Prefix TLV Sub-TLVs" registry:
Value | Description | Reference
11 | OSPFv2 Prefix Extended Flags | RFC 9792
OSPFv2 Prefix Extended Flags Registry
IANA has created the "OSPFv2 Prefix Extended Flags" registry within the "Open Shortest Path First v2 (OSPFv2) Parameters" registry group. The registry defines the bits in the Prefix Extended Flags field in the OSPFv2 Prefix Extended Flags sub-TLV as specified in Section 2. The bits are to be allocated via IETF Review [RFC8126]. Each bit definition will include:
- Bit number (counting from bit 0 as the most significant bit of the first block)
- Description
- Reference
No bits are currently defined. Bits 0-31 are to be initially marked as "Unassigned". The flags defined in this document may use either a single bit or multiple bits to represent a state, as determined by the specific requirements of the document defining them. IANA will add subsequent blocks of 32 bits upon exhaustion of the preceding 32-bit block.
OSPFv3
OSPFv3 Prefix Extended Flags Sub-TLV
IANA has allocated the following codepoint in the "OSPFv3 Extended-LSA Sub-TLVs" registry:
Value | Description | L2BM | Reference
37 | OSPFv3 Prefix Extended Flags | X | RFC 9792
OSPFv3 Prefix Extended Flags Registry
IANA has created the "OSPFv3 Prefix Extended Flags" registry within the "Open Shortest Path First v3 (OSPFv3) Parameters" registry group. The registry defines the bits in the Prefix Extended Flags field in the OSPFv2 Prefix Extended Flags sub-TLV as specified in Section 2. The bits are to be allocated via IETF Review [RFC8126]. Each bit definition will include:
- Bit number (counting from bit 0 as the most significant bit of the first block)
- Description
- Reference
No bits are currently defined. Bits 0-31 are to be initially marked as "Unassigned". The flags defined in this document may use either a single bit or multiple bits to represent a state, as determined by the specific requirements of the document defining them. IANA will add subsequent blocks of 32 bits upon exhaustion of the preceding 32-bit block.
Security Considerations
Procedures and protocol extensions defined in this document do not affect the OSPFv2 or OSPFv3 security models. See Section 5 of [RFC7684] for a discussion of OSPFv2 TLV-encoding considerations and Section 7 of [RFC8362] for a discussion of OSPFv3 security.
References
Normative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC3630]

Traffic Engineering (TE) Extensions to OSPF Version 2
D. Katz
K. Kompella
D. Yeung
September 2003
RFC 3630
DOI 10.17487/RFC3630
[RFC5340]

OSPF for IPv6
R. Coltun
D. Ferguson
J. Moy
A. Lindem
July 2008
RFC 5340
DOI 10.17487/RFC5340
[RFC7684]

OSPFv2 Prefix/Link Attribute Advertisement
P. Psenak
H. Gredler
R. Shakir
W. Henderickx
J. Tantsura
A. Lindem
November 2015
RFC 7684
DOI 10.17487/RFC7684
[RFC8126]

Guidelines for Writing an IANA Considerations Section in RFCs
M. Cotton
B. Leiba
T. Narten
June 2017
BCP 26
RFC 8126
DOI 10.17487/RFC8126
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
[RFC8362]

OSPFv3 Link State Advertisement (LSA) Extensibility
A. Lindem
A. Roy
D. Goethals
V. Reddy Vallem
F. Baker
April 2018
RFC 8362
DOI 10.17487/RFC8362
[RFC9513]

OSPFv3 Extensions for Segment Routing over IPv6 (SRv6)
Z. Li
Z. Hu
K. Talaulikar, Ed.
P. Psenak
December 2023
RFC 9513
DOI 10.17487/RFC9513
Informative References
[IANA-OSPFv2-EPF]

OSPFv2 Extended Prefix TLV Flags
IANA
[IANA-OSPFv3-PO]

OSPFv3 Prefix Options (8 bits)
IANA
Acknowledgements
The authors would like to thank Shraddha Hegde, Changwang Lin, Tom Petch, and many others for their suggestions and comments.
The authors would also like to thank Acee Lindem for aligning the terminology with existing OSPF documents and for editorial improvements.
Authors' Addresses
Ran Chen
ZTE Corporation
Nanjing
China
chen.ran@zte.com.cn
Detao Zhao
ZTE Corporation
Nanjing
China
zhao.detao@zte.com.cn
Peter Psenak
Cisco Systems
Apollo Business Center
Mlynske nivy 43
Bratislava
821 09
Slovakia
ppsenak@cisco.com
Ketan Talaulikar
Cisco Systems
India
ketant.ietf@gmail.com
Liyan Gong
China Mobile
China
gongliyan@chinamobile.com